/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// UsersApiService UsersApi service
type UsersApiService service

type ApiUserAllRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	page *int32
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserAllRequest) CVEAPIORG(cVEAPIORG string) ApiUserAllRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserAllRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserAllRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserAllRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserAllRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The current page in the paginator
func (r ApiUserAllRequest) Page(page int32) ApiUserAllRequest {
	r.page = &page
	return r
}

func (r ApiUserAllRequest) Execute() (*ListUsersResponse, *http.Response, error) {
	return r.ApiService.UserAllExecute(r)
}

/*
UserAll Retrieves information about all registered users (accessible to Secretariat)

  <h2>Access Control</h2>  <p> User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Retrieves information about all users for all organizations</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiUserAllRequest
*/
func (a *UsersApiService) UserAll(ctx context.Context) ApiUserAllRequest {
	return ApiUserAllRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return ListUsersResponse
func (a *UsersApiService) UserAllExecute(r ApiUserAllRequest) (*ListUsersResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ListUsersResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserAll")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/users"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.page != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "page", r.page, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUserCreateSingleRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	shortname string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	createUserRequest *CreateUserRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserCreateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiUserCreateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserCreateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserCreateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserCreateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserCreateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiUserCreateSingleRequest) CreateUserRequest(createUserRequest CreateUserRequest) ApiUserCreateSingleRequest {
	r.createUserRequest = &createUserRequest
	return r
}

func (r ApiUserCreateSingleRequest) Execute() (*CreateUserResponse, *http.Response, error) {
	return r.ApiService.UserCreateSingleExecute(r)
}

/*
UserCreateSingle Create a user with the provided short name as the owning organization (accessible to Admins and Secretariats)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role or be an <b>Admin</b> of the organization</p>  <h2>Expected Behavior</h2>  <p><b>Admin User:</b> Creates a user for the Admin's organization</p>  <p><b>Secretariat:</b> Creates a user for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @return ApiUserCreateSingleRequest
*/
func (a *UsersApiService) UserCreateSingle(ctx context.Context, shortname string) ApiUserCreateSingleRequest {
	return ApiUserCreateSingleRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
	}
}

// Execute executes the request
//  @return CreateUserResponse
func (a *UsersApiService) UserCreateSingleExecute(r ApiUserCreateSingleRequest) (*CreateUserResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateUserResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserCreateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/user"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.createUserRequest == nil {
		return localVarReturnValue, nil, reportError("createUserRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.createUserRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUserOrgAllRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	shortname string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	page *int32
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserOrgAllRequest) CVEAPIORG(cVEAPIORG string) ApiUserOrgAllRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserOrgAllRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserOrgAllRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserOrgAllRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserOrgAllRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The current page in the paginator
func (r ApiUserOrgAllRequest) Page(page int32) ApiUserOrgAllRequest {
	r.page = &page
	return r
}

func (r ApiUserOrgAllRequest) Execute() (*ListUsersResponse, *http.Response, error) {
	return r.ApiService.UserOrgAllExecute(r)
}

/*
UserOrgAll Retrieves all users for the organization with the specified short name (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users:</b> Retrieves information about users in the same organization</p>  <p><b>Secretariat:</b> Retrieves all user information for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @return ApiUserOrgAllRequest
*/
func (a *UsersApiService) UserOrgAll(ctx context.Context, shortname string) ApiUserOrgAllRequest {
	return ApiUserOrgAllRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
	}
}

// Execute executes the request
//  @return ListUsersResponse
func (a *UsersApiService) UserOrgAllExecute(r ApiUserOrgAllRequest) (*ListUsersResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ListUsersResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserOrgAll")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/users"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.page != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "page", r.page, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUserResetSecretRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	shortname string
	username string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserResetSecretRequest) CVEAPIORG(cVEAPIORG string) ApiUserResetSecretRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserResetSecretRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserResetSecretRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserResetSecretRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserResetSecretRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiUserResetSecretRequest) Execute() (*ResetSecretResponse, *http.Response, error) {
	return r.ApiService.UserResetSecretExecute(r)
}

/*
UserResetSecret Reset the API key for a user (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular User:</b> Resets user's own API secret</p>  <p><b>Admin User:</b> Resets any user's API secret in the Admin's organization</p>  <p><b>Secretariat:</b> Resets any user's API secret</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @param username The username of the user
 @return ApiUserResetSecretRequest
*/
func (a *UsersApiService) UserResetSecret(ctx context.Context, shortname string, username string) ApiUserResetSecretRequest {
	return ApiUserResetSecretRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
		username: username,
	}
}

// Execute executes the request
//  @return ResetSecretResponse
func (a *UsersApiService) UserResetSecretExecute(r ApiUserResetSecretRequest) (*ResetSecretResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *ResetSecretResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserResetSecret")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/user/{username}/reset_secret"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"username"+"}", url.PathEscape(parameterValueToString(r.username, "username")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUserSingleRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	shortname string
	username string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserSingleRequest) CVEAPIORG(cVEAPIORG string) ApiUserSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiUserSingleRequest) Execute() (*GetUserResponse, *http.Response, error) {
	return r.ApiService.UserSingleExecute(r)
}

/*
UserSingle Retrieves information about a user for the specified username and organization short name (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular, CNA & Admin Users:</b> Retrieves information about a user in the same organization</p>  <p><b>Secretariat:</b> Retrieves any user's information</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @param username The username of the user
 @return ApiUserSingleRequest
*/
func (a *UsersApiService) UserSingle(ctx context.Context, shortname string, username string) ApiUserSingleRequest {
	return ApiUserSingleRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
		username: username,
	}
}

// Execute executes the request
//  @return GetUserResponse
func (a *UsersApiService) UserSingleExecute(r ApiUserSingleRequest) (*GetUserResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetUserResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/user/{username}"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"username"+"}", url.PathEscape(parameterValueToString(r.username, "username")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUserUpdateSingleRequest struct {
	ctx context.Context
	ApiService *UsersApiService
	shortname string
	username string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	active *bool
	activeRolesAdd *string
	activeRolesRemove *string
	nameFirst *string
	nameLast *string
	nameMiddle *string
	nameSuffix *string
	newUsername *string
	orgShortName *string
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiUserUpdateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiUserUpdateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiUserUpdateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiUserUpdateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiUserUpdateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiUserUpdateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// The new active state for the user entry.  Accepted values are 1, true, or yes to indicate true, and 0, false, or no to indicate false
func (r ApiUserUpdateSingleRequest) Active(active bool) ApiUserUpdateSingleRequest {
	r.active = &active
	return r
}

// Add an active role to the user
func (r ApiUserUpdateSingleRequest) ActiveRolesAdd(activeRolesAdd string) ApiUserUpdateSingleRequest {
	r.activeRolesAdd = &activeRolesAdd
	return r
}

// Remove an active role from the user
func (r ApiUserUpdateSingleRequest) ActiveRolesRemove(activeRolesRemove string) ApiUserUpdateSingleRequest {
	r.activeRolesRemove = &activeRolesRemove
	return r
}

// The new first name for the user entry
func (r ApiUserUpdateSingleRequest) NameFirst(nameFirst string) ApiUserUpdateSingleRequest {
	r.nameFirst = &nameFirst
	return r
}

// The new last name for the user entry
func (r ApiUserUpdateSingleRequest) NameLast(nameLast string) ApiUserUpdateSingleRequest {
	r.nameLast = &nameLast
	return r
}

// The new middle name for the user entry
func (r ApiUserUpdateSingleRequest) NameMiddle(nameMiddle string) ApiUserUpdateSingleRequest {
	r.nameMiddle = &nameMiddle
	return r
}

// The new suffix for the user entry
func (r ApiUserUpdateSingleRequest) NameSuffix(nameSuffix string) ApiUserUpdateSingleRequest {
	r.nameSuffix = &nameSuffix
	return r
}

// The new username for the user, preferably the user&#39;s email address. Must be 3-128 characters in length; allowed characters are alphanumeric and -_@.
func (r ApiUserUpdateSingleRequest) NewUsername(newUsername string) ApiUserUpdateSingleRequest {
	r.newUsername = &newUsername
	return r
}

// The new organization for the user
func (r ApiUserUpdateSingleRequest) OrgShortName(orgShortName string) ApiUserUpdateSingleRequest {
	r.orgShortName = &orgShortName
	return r
}

func (r ApiUserUpdateSingleRequest) Execute() (*UpdateUserResponse, *http.Response, error) {
	return r.ApiService.UserUpdateSingleExecute(r)
}

/*
UserUpdateSingle Updates information about a user for the specified username and organization shortname (accessible to all registered users)

  <h2>Access Control</h2>  <p>All registered users can access this endpoint</p>  <h2>Expected Behavior</h2>  <p><b>Regular User:</b> Updates the user's own information. Only name fields may be changed.</p>  <p><b>Admin User:</b> Updates information about a user in the Admin's organization. Allowed to change all fields except org_short_name. </p>  <p><b>Secretariat:</b> Updates information about a user in any organization. Allowed to change all fields.</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param shortname The shortname of the organization
 @param username The username of the user
 @return ApiUserUpdateSingleRequest
*/
func (a *UsersApiService) UserUpdateSingle(ctx context.Context, shortname string, username string) ApiUserUpdateSingleRequest {
	return ApiUserUpdateSingleRequest{
		ApiService: a,
		ctx: ctx,
		shortname: shortname,
		username: username,
	}
}

// Execute executes the request
//  @return UpdateUserResponse
func (a *UsersApiService) UserUpdateSingleExecute(r ApiUserUpdateSingleRequest) (*UpdateUserResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateUserResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "UsersApiService.UserUpdateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/org/{shortname}/user/{username}"
	localVarPath = strings.Replace(localVarPath, "{"+"shortname"+"}", url.PathEscape(parameterValueToString(r.shortname, "shortname")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"username"+"}", url.PathEscape(parameterValueToString(r.username, "username")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}

	if r.active != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "active", r.active, "")
	}
	if r.activeRolesAdd != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "active_roles.add", r.activeRolesAdd, "")
	}
	if r.activeRolesRemove != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "active_roles.remove", r.activeRolesRemove, "")
	}
	if r.nameFirst != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name.first", r.nameFirst, "")
	}
	if r.nameLast != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name.last", r.nameLast, "")
	}
	if r.nameMiddle != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name.middle", r.nameMiddle, "")
	}
	if r.nameSuffix != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "name.suffix", r.nameSuffix, "")
	}
	if r.newUsername != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "new_username", r.newUsername, "")
	}
	if r.orgShortName != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "org_short_name", r.orgShortName, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
